#! /usr/bin/python

import numpy as np
import os, sys
sys.path.append(os.path.abspath(os.path.join(os.path.dirname(__file__), os.path.pardir)))
from denoise import denoise

d = 36
k = 10
S = np.random.normal(scale=1, size=[d, k])

# more efficient way
vals, vecs = denoise.truncatedEigen(S, k)

# direct without any extra thought
C = np.dot(S, S.T)
d, V = np.linalg.eigh(C)
vecs_t = V[:, -1*k:]
vals_t = d[-1*k:]

# test
vals_diff = vals_t - vals
if abs(vals_diff).sum() > 1e-10:
   print("eigen value test failed")
   sys.exit(1)


for l in range(len(vals)):
   if(abs(np.dot(vecs[:, l].T, vecs_t[:, l])) < 0.9999):
      print("eigen vector test failed")
      sys.exit(1)

print("test truncatedEigen() when there's not enough high dimensional data")
